##
##  rdist.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package versions
%define       V_base  7.0.0
%define       V_pl    alpha10
%define       V_opkg  7.0.0a10

#   package information
Name:         rdist
Summary:      Remote File Distribution
URL:          http://www.magnicomp.com/rdist/
Vendor:       MagniComp
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        PLUS
Group:        Filesystem
License:      BSD
Version:      %{V_opkg}
Release:      20080101

#   package options
%option       with_fsl  yes

#   list of sources
Source0:      http://www.magnicomp.com/download/rdist/rdist-%{V_base}-%{V_pl}.tar.gz
Source1:      rc.rdist
Source2:      fsl.rdist
Patch0:       rdist.patch

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, make, gcc, bison
PreReq:       OpenPKG, openpkg >= 20160101
%if "%{with_fsl}" == "yes"
BuildPreReq:  fsl
PreReq:       fsl
%endif

%description
    RDist maintains identical copies of files over multiple hosts.
    It preserves the owner, group, mode, and mtime of files if
    possible and can update programs that are executing.

%track
    prog rdist = {
        version   = %{V_base}-%{V_pl}
        url       = http://www.magnicomp.com/cgi-bin/mcdownload.cgi
        regex     = VALUE="rdist.(__VER__)"
    }

%prep
    %setup -q -n rdist-%{V_base}-%{V_pl}
    %patch -p0

%build
    CC="%{l_cc}" \
    CFLAGS="%{l_cflags -O}" \
    LDFLAGS="%{l_fsl_ldflags}" \
    LIBS="%{l_fsl_libs}" \
    YACC="bison -y" \
    ./configure \
        --prefix=%{l_prefix}
    %{l_make} %{l_mflags}

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/man/man1 \
        $RPM_BUILD_ROOT%{l_prefix}/man/man8 \
        $RPM_BUILD_ROOT%{l_prefix}/sbin \
        $RPM_BUILD_ROOT%{l_prefix}/var/rdist
    %{l_shtool} install -c -s -m 755 \
        src/rdist \
        $RPM_BUILD_ROOT%{l_prefix}/bin/
    %{l_shtool} install -c -s -m 755 \
        src/rdistd \
        $RPM_BUILD_ROOT%{l_prefix}/sbin/
    %{l_shtool} install -c -m 644 \
        doc/rdist.man \
        $RPM_BUILD_ROOT%{l_prefix}/man/man1/rdist.1
    %{l_shtool} install -c -m 644 \
        doc/rdistd.man \
        $RPM_BUILD_ROOT%{l_prefix}/man/man8/rdistd.8

    #   install run-command script
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE rc.rdist} $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d/

    #   install OSSP fsl configuration
    %{l_shtool} mkdir -f -p -m 755 $RPM_BUILD_ROOT%{l_prefix}/etc/fsl
    %{l_shtool} install -c -m 644 %{l_value -s -a} \
        %{SOURCE fsl.rdist} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/fsl/

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%config %{l_prefix}/etc/fsl/fsl.rdist'

%files -f files

%clean

%post
    #   after upgrade, restart service
    [ $1 -eq 2 ] || exit 0
    eval `%{l_rc} rdist status 2>/dev/null`
    [ ".$rdist_active" = .yes ] && %{l_rc} rdist restart
    exit 0

%preun
    #   before erase, stop service and remove log files
    [ $1 -eq 0 ] || exit 0
    %{l_rc} rdist stop 2>/dev/null
    rm -f $RPM_INSTALL_PREFIX/var/rdist/rdist.log* >/dev/null 2>&1 || true
    exit 0

